obj/proc/Fire(var/obj/O)//Main proc, defines the object.
	var/L //This will be used to determain the objects previous location.
	var/PL //Read above.
	start //Begins a loop.
	PL = L //Records the bullets previous location.
	step(O,O:dir)//Moves the object in question.
	L = O:loc //Records the bullets current location.
	sleep(1)
	if(PL == L) //If the previous location equals the current one.
		del(O) //Deletes the object, this is so that if the objects hits the borders of the map it will delete itself.
	else
		goto start
obj/Bullet
	icon = 'Bullet.dmi'
	density = 1 //This object must be dense for this to work!
	Bump(atom/a) //If the object hits anything.
		if(ismob(a)) //Checks to see if the object the object hit is a character.
			a:Die() //Kills the player.
			del(src) //Deletes the object.
		else
			del(src)
mob/proc/Die()
	if(!src.key) //If the mob is a Non-Player-Character(NPC).
		world<<"An NPC was killed!"
		del(src) //Deletes the NPC.
	else //If the mob is an actual person.
		world<<"[src] has been killed by a bullet!"
		src.loc = locate(1,1,1) //Sends the player back to the start.
mob/verb/Fire() //This is the verb that will fire the object.
	var/obj/O = new /obj/Bullet(usr.loc) //Creates an object bullet at your location.
	O:dir = usr.dir // Makes the objects direction your direction.
	O:Fire(O) // Fires the object.
mob
	icon = 'Mob.dmi'
	Login()
		usr.loc = locate(1,1,1)
turf
	icon = 'Turf.dmi'
